.nolist
include \masm32\include\masm32rt.inc

.686
.xmm
;
;   CPU architecture structure.
;
STRU_CPU_ARCH               STRUCT
                            wCPU_Arch               WORD ?
                            wReserved               WORD ?
STRU_CPU_ARCH               ENDS

;
;   System Info structure.
;
STRU_SYS_INFO               STRUCT
                                UNION               CPU_TYPE
                                    dOEMID          DWORD ?
                                    CPUArchiture    STRU_CPU_ARCH <>
                                ENDS
                            dPageSize               DWORD ?
                            pMinAppAddress          PDWORD ?
                            pMaxAppAddress          PDWORD ?
                            pActiveCPUMask          PDWORD ?
                            dNumberOfCPUS           DWORD ?
                            dCPUType                DWORD ?
                            dAllocationGramularity  DWORD ?
                            dProcessorLevel         WORD ?
                            dProcessorRevision      WORD ?
STRU_SYS_INFO               ENDS

include \masm32\macros\timers.asm			
LOOP_COUNT	= 10000


 l_htodw	PROTO : DWORD
 l_a2l       proto :dword 
Axhex2dw  PROTO : DWORD
Axa2l   proto :dword 

StrCmpSSE	PROTO: DWORD, :DWORD



.data

align  16
;hexstring    db  "ABCDEF01",0
hexstring    db "A",0

align 16
;numstring          db  "1234543210",0
numstring          db  "1",0
align 16
negnumstring   db  "-1234543210",0

align DWORD
    dVirtualBase    DWORD ?
    dVirtualSize    DWORD ?
    dSize           DWORD ?
    System_Info     STRU_SYS_INFO <>
    dPageSize       DWORD ?
    dSystemStatus   DWORD ?
    pLastByte       DWORD ?

.code
start:
;
;   Get system info
;
    INVOKE GetSystemInfo,OFFSET System_Info
    mov    eax,System_Info.dPageSize
    mov    dPageSize,eax
    lea    ebx,[eax+65536]
    mov    dVirtualSize,ebx
;
;   Reserve the space required.
;
    INVOKE VirtualAlloc,0,ebx,MEM_RESERVE,PAGE_NOACCESS
    mov    dVirtualBase,eax
    or     eax,eax
    jnz    Ok3
mov edi,3
int 3
Ok3:
;
;   Commit the space required.
;
    INVOKE VirtualAlloc,dVirtualBase,ebx,MEM_COMMIT,PAGE_READWRITE
    or     eax,eax
    jnz    Ok4
mov edi,4
int 3
Ok4:
    mov    eax,dVirtualBase
    lea    eax,[eax+ebx-2]
    mov    pLastByte,eax
	push 1
	call ShowCpu	; prints the brand string and returns SSE level@

	REPEAT 1

mov ax,word ptr hexstring
mov ebx,pLastByte
mov [ebx],ax

	invoke Sleep, 200

print "Can't time l_htodw Lingo - fails with memory access fault, skipped", 13, 10
jmp Skip5
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
;		invoke l_htodw, addr  hexstring
		invoke l_htodw, pLastByte
cmp eax,0Ah
jz Ok5
print str$(eax), 9, " - l_htodw Lingo returned a wrong value, should be 10", 13, 10
jmp Skip5
Ok5:
    counter_end
	     print str$(eax), 9, "cycles for l_htodw Lingo", 13, 10
Skip5:

	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
;		invoke Axhex2dw, addr  hexstring
		invoke Axhex2dw, pLastByte
cmp eax,0Ah
jz Ok6
print str$(eax), 9, " - Axhex2dw returned a wrong value, should be 10", 13, 10
jmp Skip6
Ok6:
    counter_end
	    print str$(eax), 9, "cycles for Axhex2dw", 13, 10
Skip6:

	invoke Sleep, 200

mov ax,word ptr numstring
mov ebx,pLastByte
mov [ebx],ax

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
;		invoke l_a2l , addr  numstring 
		invoke l_a2l , pLastByte
cmp eax,1
jz Ok7
print str$(eax), 9, " - l_a2l Lingo returned a wrong value, should be 1", 13, 10
jmp Skip7
Ok7:
    counter_end
	     print str$(eax), 9, "cycles for l_a2l  Lingo", 13, 10
Skip7:

	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
;		invoke Axa2l , addr  numstring 
		invoke Axa2l , pLastByte 
cmp eax,1
jz Ok8
print str$(eax), 9, " - Axa2l returned a wrong value, should be 1", 13, 10
jmp Skip8
Ok8:
    counter_end
	     print str$(eax), 9, "cycles for Axa2l", 13, 10
Skip8:

mov ebx,pLastByte
sub ebx,10
mov pLastByte,ebx
invoke crt_strcpy,ebx,addr negnumstring

	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke l_a2l , pLastByte
neg eax
cmp eax,1234543210
jz Ok9
neg eax
print str$(eax), 9, " - l_a2l Lingo returned a wrong value, should be -1234543210", 13, 10
jmp Skip9
Ok9:
    counter_end
	     print str$(eax), 9, "cycles for  l_a2l Lingo - negative", 13, 10
Skip9:

	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axa2l , pLastByte
neg eax
cmp eax,1234543210
jz Ok10
neg eax
print str$(eax), 9, " - Axa2l returned a wrong value, should be -1234543210", 13, 10
jmp Skip10
Ok10:
    counter_end
	     print str$(eax), 9, "cycles for Axa2l - negative ", 13, 10
Skip10:

	ENDM

	print " ", 13, 10
	print "Codesizes:", 13, 10

	print "l_htodw-Lingo:", 9
	mov   eax, l_htodw_endp
	sub	  eax, l_htodw
	print str$(eax), 13, 10

	print "Axhex2dw:", 9
	mov   eax, Axhex2dw_endp
	sub	  eax, Axhex2dw
	print str$(eax), 13, 10

	print "l_a2 - Lingo:", 9
	mov   eax, l_a2l_endp
	sub	  eax, l_a2l
	print str$(eax), 13, 10

	print "Axa2l:", 9
	mov   eax, Axa2l_endp
	sub	  eax, Axa2l
	print str$(eax), 13, 10

	inkey "--- ok ---"
	exit


push 1
call ShowCpu
ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp



option prologue:none
option epilogue:none	
align 16
db 0,0,0,0,0,0,0,0,0,0,0,0,0
l_htodw   proc lpString:dword
	mov		edx, [esp+4]
	mov     ecx,  11011111Y
	mov		[esp+4], ebx
	xor		 eax, eax
	and      ecx, [edx]
    je         @f   +1Eh
@@:
     lea      ebx, [ecx-19h]
     inc      edx
  	 add     ecx, -40h
     lea      eax, [eax*8]
	 cmovb   ebx, ecx
 	 mov    ecx,11011111Y
	 lea      eax, [eax*2+ebx+9]
     and     ecx, [edx]
     jnz      @b 
     pop     ecx
	 pop		ebx
	 jmp		ecx
l_htodw  endp
l_htodw_endp:

align 16
Axhex2dw    proc STDCALL lpszStr:DWORD
    push edi
    mov edi,[esp+8]
    xor ecx,ecx
    mov eax,0		; if you have use only full-notated hex numbers, then comment this mnemonic,
    @@:			; i.e, if you use numbers like 00000007, but not 07 or simple 7,
    movzx edx,byte ptr [edi]	; if you use short notation (07 or 7), then eax must be zeroed (mov eax,0 instead
    cmp edx,0			; xor eax,eax used, because it slightly faster, and align loop to 4 bytes).
    jz @done
    test dl,1000000Y
    setne cl
    add edx,ecx
    add edi,1
    shl eax,4h
    lea edx,[edx-30h+ecx*8]
    and edx,0fh
    add eax,edx
    jmp @B

    @done:
    pop edi
    ret 4
Axhex2dw    endp
Axhex2dw_endp:

align 16
db 0, 0, 0, 0 
l_a2l proc lpString:dword
    pop      ecx
	pop      edx
    movzx eax, byte ptr [edx]
	add		 edx, 1	
	cmp     eax,'-'
    jz         @preloop2
    test      eax, eax
    jz          baa
	movzx  ecx, byte ptr [edx]
	sub       eax, 30h
    test       ecx, ecx
    jz          baa
@@:
	lea       eax, [eax+eax*4]
	add		edx,1
	lea		eax, [eax*2+ecx-'0']
	movzx ecx, byte ptr [edx]
    test     ecx, ecx
    jnz       @b
baa:
    jmp      dword ptr [esp-2*4] 

@preloop2:
	movzx  ecx, byte ptr [edx]
	xor		 eax, eax 	
    test       ecx, ecx
    jz          baa1
@@:
	lea       eax, [eax+eax*4]
	add		edx,1
	lea		eax, [eax*2+ecx-'0']
	movzx ecx, byte ptr [edx]
    test     ecx, ecx
    jnz       @b
    sub      eax, 1
    xor      eax, -1
baa1:
    jmp      dword ptr [esp-2*4] 
l_a2l endp
l_a2l_endp:

align 16
Axa2l proc lpszString:DWORD
    pop ecx
    pop edx
    push ecx
    push edi
    xor edi,edi
        xor eax,eax
        movzx ecx,byte ptr [edx]
        cmp cl,'-'
        jnz @preloop
        inc edx
        dec edi
@mainloop:
        mov cl, byte ptr [edx]
@preloop:
        jecxz @done
        lea eax,[eax+eax*4]
        inc edx
        lea eax,[eax*2+ecx-'0']
        jmp @mainloop
 @done:        
    add eax,edi
    xor eax,edi
    pop edi
    ret
Axa2l endp
Axa2l_endp:

option prologue:prologuedef
option epilogue:epiloguedef

end start

